var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var __privateMethod = (obj, member, method) => {
  __accessCheck(obj, member, "access private method");
  return method;
};
var _a, _b, _session, _user, _shareToken, _currentDirectory, _attachmentDirectory, _getImageAttachmentUrl, getImageAttachmentUrl_fn, _getMediaPreviewUrl, getMediaPreviewUrl_fn, _textApiParams, textApiParams_fn, _previewUrl, previewUrl_fn, _davUrl, davUrl_fn, _relativePath, relativePath_fn, _filePath, filePath_fn;
import { Editor, mergeAttributes, Mark, Node, InputRule, wrappingInputRule, isNodeActive, markInputRule, markPasteRule, Extension } from "@tiptap/core";
import { EditorContent, NodeViewWrapper, VueNodeViewRenderer, NodeViewContent } from "@tiptap/vue-2";
import Document from "@tiptap/extension-document";
import TipTapParagraph from "@tiptap/extension-paragraph";
import Text from "@tiptap/extension-text";
import Blockquote from "@tiptap/extension-blockquote";
import OrderedList from "@tiptap/extension-ordered-list";
import ListItem from "@tiptap/extension-list-item";
import Code from "@tiptap/extension-code";
import TiptapCodeBlock from "@tiptap/extension-code-block";
import HorizontalRule from "@tiptap/extension-horizontal-rule";
import Dropcursor from "@tiptap/extension-dropcursor";
import TipTapHardBreak from "@tiptap/extension-hard-break";
import { Table as Table$1 } from "@tiptap/extension-table";
import { TableCell as TableCell$1 } from "@tiptap/extension-table-cell";
import { TableHeader as TableHeader$1 } from "@tiptap/extension-table-header";
import { TableRow as TableRow$1 } from "@tiptap/extension-table-row";
import { TextSelection, Plugin, PluginKey } from "prosemirror-state";
import { isInTable, selectionCell, moveCellForward } from "@_ueberdosis/prosemirror-tables";
import TiptapImage from "@tiptap/extension-image";
import axios from "@nextcloud/axios";
import ClickOutside from "vue-click-outside";
import { NcButton, NcUserBubble } from "@nextcloud/vue";
import { generateUrl, generateRemoteUrl } from "@nextcloud/router";
import Vue from "vue";
import Vuex, { Store } from "vuex";
import { getBuilder } from "@nextcloud/browser-storage";
import debounce from "debounce";
import { getLoggerBuilder } from "@nextcloud/logger";
import TipTapHeading from "@tiptap/extension-heading";
import { v4 } from "uuid";
import TiptapBulletList from "@tiptap/extension-bullet-list";
import TiptapTaskList from "@tiptap/extension-task-list";
import TipTapTaskItem from "@tiptap/extension-task-item";
import { findParentNodeClosestToPos } from "prosemirror-utils";
import container from "markdown-it-container";
import TipTapMention from "@tiptap/extension-mention";
import { getCurrentUser } from "@nextcloud/auth";
import TipTapItalic from "@tiptap/extension-italic";
import TipTapLink from "@tiptap/extension-link";
import MarkdownIt from "markdown-it";
import taskLists from "@hedgedoc/markdown-it-task-lists";
import markdownitMentions from "@quartzy/markdown-it-mentions";
import TipTapStrike from "@tiptap/extension-strike";
import { Bold, starInputRegex, starPasteRegex, underscoreInputRegex, underscorePasteRegex } from "@tiptap/extension-bold";
import TipTapUnderline from "@tiptap/extension-underline";
import pathNormalize from "path-normalize";
function normalizeComponent(scriptExports, render13, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render13) {
    options.render = render13;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function(context) {
      context = context || this.$vnode && this.$vnode.ssrContext || this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(
        this,
        (options.functional ? this.parent : this).$root.$options.shadowRoot
      );
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}
const _sfc_main$b = {
  name: "BaseReader",
  components: { EditorContent },
  inject: ["renderHtml", "extensions"],
  props: {
    content: {
      type: String,
      required: true
    }
  },
  computed: {
    htmlContent() {
      return this.renderHtml(this.content);
    }
  },
  watch: {
    content() {
      this.updateContent();
    }
  },
  created() {
    this.$editor = this.createEditor();
    this.$editor.setOptions({ editable: false });
  },
  beforeDestroy() {
    this.$editor.destroy();
  },
  methods: {
    createEditor() {
      return new Editor({
        content: this.htmlContent,
        extensions: this.extensions()
      });
    },
    updateContent() {
      this.$editor.commands.setContent(this.htmlContent);
    }
  }
};
var _sfc_render$b = function render() {
  var _vm = this, _c = _vm._self._c;
  return _vm.$editor ? _c("EditorContent", { attrs: { "id": "read-only-editor", "editor": _vm.$editor } }) : _vm._e();
};
var _sfc_staticRenderFns$b = [];
var __component__$b = /* @__PURE__ */ normalizeComponent(
  _sfc_main$b,
  _sfc_render$b,
  _sfc_staticRenderFns$b,
  false,
  null,
  null,
  null,
  null
);
const BaseReader = __component__$b.exports;
const FrontMatter = TiptapCodeBlock.extend({
  name: "frontMatter",
  draggable: false,
  renderHTML({ node, HTMLAttributes }) {
    return this.parent({
      node,
      HTMLAttributes: mergeAttributes(HTMLAttributes, { "data-title": t("text", "Front matter"), class: "frontmatter" })
    });
  },
  parseHTML() {
    return [{
      tag: "pre#frontmatter",
      preserveWhitespace: "full",
      priority: 9001,
      attrs: {
        language: "yaml"
      }
    }];
  },
  toMarkdown: (state, node) => {
    if (!state.out.match(/^\s*/))
      throw Error("FrontMatter must be the first node of the document!");
    const text = node.textContent;
    const dashes = text.match(/-{3,}/gm);
    const separator = "-".repeat(dashes ? dashes.sort().slice(-1)[0].length + 1 : 3);
    state.write("");
    state.out = "";
    state.write(`${separator}
`);
    state.text(text, false);
    state.ensureNewLine();
    state.write(separator);
    state.closeBlock(node);
  },
  addInputRules() {
    return [
      {
        find: /^---$/g,
        handler: ({ state, range, chain }) => {
          if (range.from === 1) {
            if (state.doc.resolve(1).parent.type.name === this.name)
              return false;
            chain().deleteRange(range).insertContentAt(0, {
              type: this.name
            });
            return true;
          }
          return false;
        }
      }
    ];
  },
  addCommands() {
    return {};
  },
  addPasteRules: () => [],
  addProseMirrorPlugins: () => []
});
/*
 * @copyright Copyright (c) 2022 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
*/
const HardBreak = TipTapHardBreak.extend({
  toMarkdown(state, node, parent, index) {
    var _a2;
    for (let i = index + 1; i < parent.childCount; i++) {
      if (parent.child(i).type !== node.type) {
        if ((_a2 = parent.child(i).text) == null ? void 0 : _a2.startsWith("\n"))
          state.write("  ");
        else
          state.write("  \n");
        return;
      }
    }
  }
});
const KeepSyntax = Mark.create({
  name: "keep-syntax",
  parseHTML() {
    return [
      {
        tag: "span.keep-md"
      }
    ];
  },
  renderHTML() {
    return ["span", { class: "keep-md" }, 0];
  },
  toMarkdown: {
    open: "",
    close: "",
    mixable: true,
    escape: false,
    expelEnclosingWhitespace: true
  },
  onUpdate() {
    const tr = this.editor.state.tr;
    this.editor.state.doc.descendants((node, pos, parent, index) => {
      if (node.marks.findIndex((mark) => mark.type.name === this.name) !== -1) {
        if (node.type.name !== "text" || node.text.length !== 1) {
          tr.removeMark(pos, pos + node.nodeSize, this.type);
        }
      }
    });
    if (tr.docChanged) {
      tr.setMeta("addToHistory", false);
      tr.setMeta("preventUpdate", true);
      this.editor.view.dispatch(tr);
    }
  }
});
const TableCaption = Node.create({
  name: "tableCaption",
  content: "inline*",
  addAttributes() {
    return {};
  },
  renderHTML() {
    return ["caption"];
  },
  toMarkdown(state, node) {
  },
  parseHTML() {
    return [
      { tag: "table caption", priority: 90 }
    ];
  }
});
const TableCell = TableCell$1.extend({
  content: "inline*",
  toMarkdown(state, node) {
    state.write(" ");
    state.renderInline(node);
    state.write(" |");
  },
  parseHTML() {
    return [
      { tag: "td" },
      { tag: "th" },
      { tag: "table thead ~ tbody th", priority: 70 },
      { tag: "table thead ~ tbody td", priority: 70 }
    ];
  }
});
const TableHeader = TableHeader$1.extend({
  content: "inline*",
  toMarkdown(state, node) {
    state.write(" ");
    state.renderInline(node);
    state.write(" |");
  },
  parseHTML() {
    return [
      { tag: "table thead:empty ~ tbody :first-child th", priority: 80 },
      { tag: "table thead:empty ~ tbody :first-child td", priority: 80 },
      { tag: "table thead :first-child th", priority: 60 },
      { tag: "table thead :first-child td", priority: 60 },
      { tag: "table tbody :first-child th", priority: 60 },
      { tag: "table tbody :first-child td", priority: 60 },
      { tag: "table > :first-child > th", priority: 60 },
      { tag: "table > :first-child > td", priority: 60 }
    ];
  }
});
const TableRow = TableRow$1.extend({
  content: "tableCell*",
  toMarkdown(state, node) {
    state.write("|");
    state.renderInline(node);
    state.ensureNewLine();
  },
  parseHTML() {
    return [
      { tag: "tr", priority: 80 }
    ];
  }
});
const TableHeadRow = TableRow.extend({
  name: "tableHeadRow",
  content: "tableHeader*",
  toMarkdown(state, node) {
    state.write("|");
    state.renderInline(node);
    state.ensureNewLine();
    state.write("|");
    node.forEach((cell) => {
      state.write(state.repeat("-", cell.textContent.length + 2));
      state.write("|");
    });
    state.ensureNewLine();
  },
  parseHTML() {
    return [
      { tag: "tr", priority: 70 }
    ];
  }
});
function createTable(schema, rowsCount, colsCount, cellContent) {
  const headerCells = [];
  const cells = [];
  for (let index = 0; index < colsCount; index += 1) {
    const cell = schema.nodes.tableCell.createAndFill();
    if (cell) {
      cells.push(cell);
    }
    const headerCell = schema.nodes.tableHeader.createAndFill();
    if (headerCell) {
      headerCells.push(headerCell);
    }
  }
  const headRow = schema.nodes.tableHeadRow.createChecked(null, headerCells);
  const rows = [];
  for (let index = 1; index < rowsCount; index += 1) {
    rows.push(schema.nodes.tableRow.createChecked(null, cells));
  }
  return schema.nodes.table.createChecked(null, [headRow, ...rows]);
}
function findSameCellInNextRow($cell) {
  if ($cell.index(-1) === $cell.node(-1).childCount - 1) {
    return null;
  }
  let cellStart = $cell.after();
  const table = $cell.node(-1);
  for (let row = $cell.indexAfter(-1); row < table.childCount; row++) {
    const rowNode = table.child(row);
    if (rowNode.childCount >= $cell.index()) {
      for (let cell = 0; cell < $cell.index(); cell++) {
        const cellNode = rowNode.child(cell);
        cellStart += cellNode.nodeSize;
      }
      return cellStart + 1;
    }
    cellStart += rowNode.nodeSize;
  }
}
const Table = Table$1.extend({
  content: "tableCaption? tableHeadRow tableRow*",
  addExtensions() {
    return [
      TableCaption,
      TableCell,
      TableHeader,
      TableHeadRow,
      TableRow
    ];
  },
  addCommands() {
    return {
      ...this.parent(),
      insertTable: () => ({ tr, dispatch, editor }) => {
        if (isInTable(tr))
          return false;
        const node = createTable(editor.schema, 3, 3);
        if (dispatch) {
          const offset = tr.selection.anchor + 1;
          tr.replaceSelectionWith(node).scrollIntoView().setSelection(TextSelection.near(tr.doc.resolve(offset)));
        }
        return true;
      },
      leaveTable: () => ({ tr, dispatch, editor }) => {
        if (!isInTable(tr))
          return false;
        const { $head, empty } = tr.selection;
        if (!empty)
          return false;
        const tableDepth = $head.depth < 3 ? 1 : $head.depth - 2;
        if (dispatch) {
          const $next = tr.doc.resolve($head.after(tableDepth) + 1);
          const selection = TextSelection.near($next);
          dispatch(tr.setSelection(selection).scrollIntoView());
        }
        return true;
      },
      goToNextRow: () => ({ tr, dispatch, editor }) => {
        if (!isInTable(tr))
          return false;
        const cell = findSameCellInNextRow(selectionCell(tr));
        if (cell == null)
          return;
        if (dispatch) {
          const $cell = tr.doc.resolve(cell);
          const selection = TextSelection.between($cell, moveCellForward($cell));
          dispatch(tr.setSelection(selection).scrollIntoView());
        }
        return true;
      }
    };
  },
  renderHTML({ HTMLAttributes }) {
    return ["table", mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  },
  toMarkdown(state, node) {
    state.renderContent(node);
    state.closeBlock(node);
  },
  addKeyboardShortcuts() {
    return {
      ...this.parent(),
      Tab: () => this.editor.commands.goToNextCell() || this.editor.commands.leaveTable(),
      Enter: () => {
        if (this.editor.commands.goToNextRow()) {
          return true;
        }
        if (!this.editor.can().addRowAfter()) {
          return false;
        }
        return this.editor.chain().addRowAfter().goToNextRow().run();
      }
    };
  }
});
const SET_VIEW_WIDTH = "SET_VIEW_WIDTH";
const SET_SHOW_AUTHOR_ANNOTATIONS = "SET_SHOW_AUTHOR_ANNOTATIONS";
const SET_CURRENT_SESSION = "SET_CURRENT_SESSION";
const SET_HEADINGS = "SET_HEADINGS";
/**
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const getClientWidth = () => document.documentElement.clientWidth;
const plugin = ({ commit }) => {
  const onResize = debounce(() => {
    commit(SET_VIEW_WIDTH, getClientWidth());
  }, 100);
  window.addEventListener("resize", onResize);
};
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const persistentStorage = getBuilder("text").persist().build();
Vue.use(Vuex);
const store$1 = new Store({
  plugins: [plugin],
  state: {
    showAuthorAnnotations: persistentStorage.getItem("showAuthorAnnotations") === "true",
    currentSession: persistentStorage.getItem("currentSession"),
    viewWidth: getClientWidth(),
    headings: Object.freeze([])
  },
  mutations: {
    [SET_VIEW_WIDTH](state, value) {
      state.viewWidth = value;
    },
    [SET_SHOW_AUTHOR_ANNOTATIONS](state, value) {
      state.showAuthorAnnotations = value;
      persistentStorage.setItem("showAuthorAnnotations", "" + value);
    },
    [SET_CURRENT_SESSION](state, value) {
      state.currentSession = value;
      persistentStorage.setItem("currentSession", value);
    },
    [SET_HEADINGS](state, value) {
      if (state.headings.length !== value.length) {
        state.headings = Object.freeze(value);
        return;
      }
      const old = state.headings;
      const headings = value.map((row, index) => {
        const previous = old[index].level;
        return Object.freeze({
          ...row,
          previous
        });
      });
      state.headings = Object.freeze(headings);
    }
  },
  getters: {
    isMobileView({ viewWidth }) {
      return viewWidth < 768;
    },
    hasHeadings({ headings }) {
      return headings.length > 0;
    }
  },
  actions: {
    setShowAuthorAnnotations({ commit }, value) {
      commit(SET_SHOW_AUTHOR_ANNOTATIONS, value);
    },
    setCurrentSession({ commit }, value) {
      commit(SET_CURRENT_SESSION, value);
    },
    setHeadings({ commit }, value) {
      commit(SET_HEADINGS, value);
    }
  }
});
/*
 * @copyright Copyright (c) 2021 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const store = {
  data() {
    return {
      $store: store$1
    };
  },
  beforeMount() {
    if (typeof this.$store === "undefined") {
      this.$store = store$1;
    }
  }
};
const logger = getLoggerBuilder().setApp("text").detectUser().build();
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const mimetypesImages = [
  "image/png",
  "image/jpeg",
  "image/jpg",
  "image/gif",
  "image/x-xbitmap",
  "image/x-ms-bmp",
  "image/bmp",
  "image/svg+xml",
  "image/webp"
];
if (!((_a = window.oc_appswebroots) == null ? void 0 : _a.richdocuments) && !((_b = window.oc_appswebroots) == null ? void 0 : _b.onlyoffice))
  ;
/**
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const EDITOR = Symbol("tiptap:editor");
const ATTACHMENT_RESOLVER = Symbol("attachment:resolver");
const useEditorMixin = {
  inject: {
    $editor: { from: EDITOR, default: null }
  }
};
const useAttachmentResolver = {
  inject: {
    $attachmentResolver: {
      from: ATTACHMENT_RESOLVER,
      default: {
        resolve(src) {
          logger.warn("No attachment resolver provided. Some attachment sources cannot be resolved.");
          return [src];
        }
      }
    }
  }
};
const _sfc_main$a = {
  name: "AlertDecagramIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var _sfc_render$a = function render2() {
  var _vm = this, _c = _vm._self._c;
  return _c("span", _vm._b({ staticClass: "material-design-icon alert-decagram-icon", attrs: { "aria-hidden": !_vm.title, "aria-label": _vm.title, "role": "img" }, on: { "click": function($event) {
    return _vm.$emit("click", $event);
  } } }, "span", _vm.$attrs, false), [_c("svg", { staticClass: "material-design-icon__svg", attrs: { "fill": _vm.fillColor, "width": _vm.size, "height": _vm.size, "viewBox": "0 0 24 24" } }, [_c("path", { attrs: { "d": "M23,12L20.56,9.22L20.9,5.54L17.29,4.72L15.4,1.54L12,3L8.6,1.54L6.71,4.72L3.1,5.53L3.44,9.21L1,12L3.44,14.78L3.1,18.47L6.71,19.29L8.6,22.47L12,21L15.4,22.46L17.29,19.28L20.9,18.46L20.56,14.78L23,12M13,17H11V15H13V17M13,13H11V7H13V13Z" } }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var _sfc_staticRenderFns$a = [];
var __component__$a = /* @__PURE__ */ normalizeComponent(
  _sfc_main$a,
  _sfc_render$a,
  _sfc_staticRenderFns$a,
  false,
  null,
  null,
  null,
  null
);
const MDI_Danger = __component__$a.exports;
const _sfc_main$9 = {
  name: "DeleteIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var _sfc_render$9 = function render3() {
  var _vm = this, _c = _vm._self._c;
  return _c("span", _vm._b({ staticClass: "material-design-icon delete-icon", attrs: { "aria-hidden": !_vm.title, "aria-label": _vm.title, "role": "img" }, on: { "click": function($event) {
    return _vm.$emit("click", $event);
  } } }, "span", _vm.$attrs, false), [_c("svg", { staticClass: "material-design-icon__svg", attrs: { "fill": _vm.fillColor, "width": _vm.size, "height": _vm.size, "viewBox": "0 0 24 24" } }, [_c("path", { attrs: { "d": "M19,4H15.5L14.5,3H9.5L8.5,4H5V6H19M6,19A2,2 0 0,0 8,21H16A2,2 0 0,0 18,19V7H6V19Z" } }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var _sfc_staticRenderFns$9 = [];
var __component__$9 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$9,
  _sfc_render$9,
  _sfc_staticRenderFns$9,
  false,
  null,
  null,
  null,
  null
);
const MDI_Delete = __component__$9.exports;
const _sfc_main$8 = {
  name: "ImageOutlineIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var _sfc_render$8 = function render4() {
  var _vm = this, _c = _vm._self._c;
  return _c("span", _vm._b({ staticClass: "material-design-icon image-outline-icon", attrs: { "aria-hidden": !_vm.title, "aria-label": _vm.title, "role": "img" }, on: { "click": function($event) {
    return _vm.$emit("click", $event);
  } } }, "span", _vm.$attrs, false), [_c("svg", { staticClass: "material-design-icon__svg", attrs: { "fill": _vm.fillColor, "width": _vm.size, "height": _vm.size, "viewBox": "0 0 24 24" } }, [_c("path", { attrs: { "d": "M19,19H5V5H19M19,3H5A2,2 0 0,0 3,5V19A2,2 0 0,0 5,21H19A2,2 0 0,0 21,19V5A2,2 0 0,0 19,3M13.96,12.29L11.21,15.83L9.25,13.47L6.5,17H17.5L13.96,12.29Z" } }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var _sfc_staticRenderFns$8 = [];
var __component__$8 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$8,
  _sfc_render$8,
  _sfc_staticRenderFns$8,
  false,
  null,
  null,
  null,
  null
);
const MDI_Image = __component__$8.exports;
const _sfc_main$7 = {
  name: "InformationIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var _sfc_render$7 = function render5() {
  var _vm = this, _c = _vm._self._c;
  return _c("span", _vm._b({ staticClass: "material-design-icon information-icon", attrs: { "aria-hidden": !_vm.title, "aria-label": _vm.title, "role": "img" }, on: { "click": function($event) {
    return _vm.$emit("click", $event);
  } } }, "span", _vm.$attrs, false), [_c("svg", { staticClass: "material-design-icon__svg", attrs: { "fill": _vm.fillColor, "width": _vm.size, "height": _vm.size, "viewBox": "0 0 24 24" } }, [_c("path", { attrs: { "d": "M13,9H11V7H13M13,17H11V11H13M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2Z" } }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var _sfc_staticRenderFns$7 = [];
var __component__$7 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$7,
  _sfc_render$7,
  _sfc_staticRenderFns$7,
  false,
  null,
  null,
  null,
  null
);
const MDI_Info = __component__$7.exports;
const _sfc_main$6 = {
  name: "CheckboxMarkedCircleIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var _sfc_render$6 = function render6() {
  var _vm = this, _c = _vm._self._c;
  return _c("span", _vm._b({ staticClass: "material-design-icon checkbox-marked-circle-icon", attrs: { "aria-hidden": !_vm.title, "aria-label": _vm.title, "role": "img" }, on: { "click": function($event) {
    return _vm.$emit("click", $event);
  } } }, "span", _vm.$attrs, false), [_c("svg", { staticClass: "material-design-icon__svg", attrs: { "fill": _vm.fillColor, "width": _vm.size, "height": _vm.size, "viewBox": "0 0 24 24" } }, [_c("path", { attrs: { "d": "M10,17L5,12L6.41,10.58L10,14.17L17.59,6.58L19,8M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2Z" } }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var _sfc_staticRenderFns$6 = [];
var __component__$6 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$6,
  _sfc_render$6,
  _sfc_staticRenderFns$6,
  false,
  null,
  null,
  null,
  null
);
const MDI_Positive = __component__$6.exports;
const _sfc_main$5 = {
  name: "AlertIcon",
  emits: ["click"],
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
var _sfc_render$5 = function render7() {
  var _vm = this, _c = _vm._self._c;
  return _c("span", _vm._b({ staticClass: "material-design-icon alert-icon", attrs: { "aria-hidden": !_vm.title, "aria-label": _vm.title, "role": "img" }, on: { "click": function($event) {
    return _vm.$emit("click", $event);
  } } }, "span", _vm.$attrs, false), [_c("svg", { staticClass: "material-design-icon__svg", attrs: { "fill": _vm.fillColor, "width": _vm.size, "height": _vm.size, "viewBox": "0 0 24 24" } }, [_c("path", { attrs: { "d": "M13 14H11V9H13M13 18H11V16H13M1 21H23L12 2L1 21Z" } }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var _sfc_staticRenderFns$5 = [];
var __component__$5 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$5,
  _sfc_render$5,
  _sfc_staticRenderFns$5,
  false,
  null,
  null,
  null,
  null
);
const MDI_Warn = __component__$5.exports;
const DEFAULT_ICON_SIZE = 20;
const makeIcon = (original) => ({
  functional: true,
  render(h, { data, props }) {
    return h(original, {
      data,
      key: data.key,
      staticClass: data.staticClass,
      props: { size: DEFAULT_ICON_SIZE, ...props }
    });
  }
});
const Danger = makeIcon(MDI_Danger);
const Delete = makeIcon(MDI_Delete);
const Image$2 = makeIcon(MDI_Image);
const Info = makeIcon(MDI_Info);
const Positive = makeIcon(MDI_Positive);
const Warn = makeIcon(MDI_Warn);
const ImageView_vue_vue_type_style_index_0_scoped_3111fc03_lang = "";
const getQueryVariable$1 = (src, variable) => {
  const query = src.split("?")[1];
  if (typeof query === "undefined") {
    return;
  }
  const vars = query.split(/[&#]/);
  if (typeof vars === "undefined") {
    return;
  }
  for (let i = 0; i < vars.length; i++) {
    const pair = vars[i].split("=");
    if (decodeURIComponent(pair[0]) === variable) {
      return decodeURIComponent(pair[1]);
    }
  }
};
class LoadImageError extends Error {
  constructor(reason, imageUrl) {
    super((reason == null ? void 0 : reason.message) || t("text", "Failed to load"));
    this.reason = reason;
    this.imageUrl = imageUrl;
  }
}
const _sfc_main$4 = {
  name: "ImageView",
  components: {
    ImageIcon: Image$2,
    DeleteIcon: Delete,
    NcButton,
    NodeViewWrapper
  },
  directives: {
    ClickOutside
  },
  mixins: [
    store,
    useAttachmentResolver
  ],
  props: ["editor", "node", "extension", "updateAttributes", "deleteNode"],
  data() {
    return {
      imageLoaded: false,
      loaded: false,
      failed: false,
      showIcons: false,
      imageUrl: null,
      errorMessage: null,
      attachmentType: null,
      attachmentMetadata: {}
    };
  },
  computed: {
    isMediaAttachment() {
      return this.attachmentType === this.$attachmentResolver.ATTACHMENT_TYPE_MEDIA;
    },
    editable() {
      return this.editor.isEditable;
    },
    showDeleteIcon() {
      return this.editable && this.showIcons;
    },
    showImageDeleteIcon() {
      return this.showDeleteIcon && !this.isMediaAttachment;
    },
    canDisplayImage() {
      if (!this.isSupportedImage) {
        return false;
      }
      if (this.failed && this.loaded) {
        return true;
      }
      return this.loaded && this.imageLoaded;
    },
    imageFileId() {
      return getQueryVariable$1(this.src, "fileId");
    },
    isSupportedImage() {
      return typeof this.mime === "undefined" || mimetypesImages.indexOf(this.mime) !== -1;
    },
    internalLinkOrImage() {
      if (this.imageFileId) {
        return generateUrl("/f/" + this.imageFileId);
      }
      return this.src;
    },
    src: {
      get() {
        return this.node.attrs.src || "";
      },
      set(src) {
        this.updateAttributes({
          src
        });
      }
    },
    alt: {
      get() {
        return this.node.attrs.alt ? this.node.attrs.alt : "";
      },
      set(alt) {
        this.updateAttributes({
          alt
        });
      }
    },
    t() {
      return (a, s) => window.t(a, s);
    },
    token() {
      return document.getElementById("sharingToken") && document.getElementById("sharingToken").value;
    }
  },
  beforeMount() {
    if (!this.isSupportedImage) {
      this.failed = true;
      this.imageLoaded = false;
      this.loaded = true;
      this.errorMessage = t("text", "Unsupported image type");
      return;
    }
    this.init().catch(this.onImageLoadFailure);
  },
  methods: {
    async init() {
      const candidates = this.$attachmentResolver.resolve(this.src);
      return this.load(candidates);
    },
    async load(candidates) {
      const [candidate, ...fallbacks] = candidates;
      return this.loadImage(candidate.url, candidate.type, candidate.name).catch((e) => {
        if (fallbacks.length > 0) {
          return this.load(fallbacks);
        }
        return Promise.reject(e);
      });
    },
    async loadImage(imageUrl, attachmentType, name = null) {
      return new Promise((resolve, reject) => {
        const img = new Image();
        img.onload = async () => {
          this.imageUrl = imageUrl;
          this.imageLoaded = true;
          this.loaded = true;
          this.attachmentType = attachmentType;
          if (attachmentType === this.$attachmentResolver.ATTACHMENT_TYPE_MEDIA) {
            await this.loadMediaMetadata(name);
          }
          resolve(imageUrl);
        };
        img.onerror = (e) => {
          reject(new LoadImageError(e, imageUrl));
        };
        img.src = imageUrl;
      });
    },
    loadMediaMetadata(name) {
      const metadataUrl = this.$attachmentResolver.getMediaMetadataUrl(name);
      return axios.get(metadataUrl).then((response) => {
        this.attachmentMetadata = response.data;
      }).catch((error) => {
        logger.error("Failed to load media metadata", { error });
      });
    },
    onImageLoadFailure(err) {
      this.failed = true;
      this.imageLoaded = false;
      this.loaded = true;
      this.errorMessage = err.message;
      if (err instanceof LoadImageError) {
        this.errorMessage = `${this.errorMessage} ${this.src}`;
      }
      this.$emit("error", { error: err, src: this.src });
    },
    updateAlt(event) {
      this.updateAttributes({
        alt: event.target.value
      });
    },
    onLoaded() {
      this.loaded = true;
      this.$nextTick(() => {
        this.editor.commands.scrollIntoView();
      });
    }
  }
};
var _sfc_render$4 = function render8() {
  var _vm = this, _c = _vm._self._c;
  return _c("NodeViewWrapper", [_c("div", { staticClass: "image image-view", class: { "icon-loading": !_vm.loaded, "image-view--failed": _vm.failed }, attrs: { "data-component": "image-view", "data-src": _vm.src } }, [_vm.canDisplayImage ? _c("div", { directives: [{ name: "click-outside", rawName: "v-click-outside", value: () => _vm.showIcons = false, expression: "() => showIcons = false" }], staticClass: "image__view", on: { "click": function($event) {
    _vm.showIcons = true;
  }, "mouseover": function($event) {
    _vm.showIcons = true;
  }, "mouseleave": function($event) {
    _vm.showIcons = false;
  } } }, [_c("transition", { attrs: { "name": "fade" } }, [!_vm.failed ? [_vm.isMediaAttachment ? _c("div", { staticClass: "media" }, [_c("div", { staticClass: "media__wrapper" }, [_c("img", { directives: [{ name: "show", rawName: "v-show", value: _vm.loaded, expression: "loaded" }], staticClass: "image__main", attrs: { "src": _vm.imageUrl }, on: { "load": _vm.onLoaded } }), _c("div", { staticClass: "metadata" }, [_c("span", { staticClass: "name" }, [_vm._v(_vm._s(_vm.alt))]), _c("span", { staticClass: "size" }, [_vm._v(_vm._s(_vm.attachmentMetadata.size))])])]), _vm.showDeleteIcon ? _c("div", { staticClass: "buttons" }, [_c("NcButton", { attrs: { "aria-label": _vm.t("text", "Delete this attachment"), "title": _vm.t("text", "Delete this attachment") }, on: { "click": _vm.deleteNode }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("DeleteIcon")];
  }, proxy: true }], null, false, 3930079857) })], 1) : _vm._e()]) : _c("div", [_c("img", { directives: [{ name: "show", rawName: "v-show", value: _vm.loaded, expression: "loaded" }], staticClass: "image__main", attrs: { "src": _vm.imageUrl }, on: { "load": _vm.onLoaded } })])] : [_c("ImageIcon", { staticClass: "image__main image__main--broken-icon", attrs: { "size": 100 } })]], 2), _c("transition", { attrs: { "name": "fade" } }, [!_vm.isMediaAttachment ? _c("div", { directives: [{ name: "show", rawName: "v-show", value: _vm.loaded, expression: "loaded" }], staticClass: "image__caption" }, [_c("div", { staticClass: "image__caption__wrapper" }, [_c("input", { directives: [{ name: "show", rawName: "v-show", value: !_vm.isMediaAttachment, expression: "!isMediaAttachment" }], ref: "altInput", staticClass: "image__caption__input", attrs: { "type": "text", "disabled": !_vm.editable }, domProps: { "value": _vm.alt }, on: { "keyup": function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
      return null;
    return _vm.updateAlt.apply(null, arguments);
  } } }), _vm.showImageDeleteIcon ? _c("div", { staticClass: "image__caption__delete" }, [_c("NcButton", { attrs: { "aria-label": _vm.t("text", "Delete this image"), "title": _vm.t("text", "Delete this image") }, on: { "click": _vm.deleteNode }, scopedSlots: _vm._u([{ key: "icon", fn: function() {
    return [_c("DeleteIcon")];
  }, proxy: true }], null, false, 3930079857) })], 1) : _vm._e()])]) : _vm._e()])], 1) : _c("div", { staticClass: "image-view__cant_display" }, [_c("transition", { attrs: { "name": "fade" } }, [_c("div", { directives: [{ name: "show", rawName: "v-show", value: _vm.loaded, expression: "loaded" }] }, [_c("a", { attrs: { "href": _vm.internalLinkOrImage, "target": "_blank" } }, [!_vm.isSupportedImage ? _c("span", [_vm._v(_vm._s(_vm.alt))]) : _vm._e()])])]), _vm.isSupportedImage ? _c("transition", { attrs: { "name": "fade" } }, [_c("div", { directives: [{ name: "show", rawName: "v-show", value: _vm.loaded, expression: "loaded" }], staticClass: "image__caption" }, [_c("input", { ref: "altInput", attrs: { "type": "text", "disabled": !_vm.editable }, domProps: { "value": _vm.alt }, on: { "keyup": function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
      return null;
    return _vm.updateAlt();
  } } })])]) : _vm._e()], 1), _vm.errorMessage ? _c("small", { staticClass: "image__error-message" }, [_vm._v(" " + _vm._s(_vm.errorMessage) + " ")]) : _vm._e()])]);
};
var _sfc_staticRenderFns$4 = [];
var __component__$4 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$4,
  _sfc_render$4,
  _sfc_staticRenderFns$4,
  false,
  null,
  "3111fc03",
  null,
  null
);
const ImageView = __component__$4.exports;
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Image$1 = TiptapImage.extend({
  selectable: false,
  renderHTML() {
    return ["img"];
  },
  addOptions() {
    var _a2;
    return {
      ...(_a2 = this.parent) == null ? void 0 : _a2.call(this)
    };
  },
  addNodeView() {
    return VueNodeViewRenderer(ImageView);
  },
  addProseMirrorPlugins() {
    return [
      new Plugin({
        props: {
          handleDrop: (view, event, slice) => {
            if (event.dataTransfer.files && event.dataTransfer.files.length > 0) {
              const coordinates = view.posAtCoords({ left: event.clientX, top: event.clientY });
              const customEvent = new CustomEvent("file-drop", {
                bubbles: true,
                detail: {
                  files: event.dataTransfer.files,
                  position: coordinates.pos
                }
              });
              event.target.dispatchEvent(customEvent);
              return true;
            }
          },
          handlePaste: (view, event, slice) => {
            if (event.clipboardData.files && event.clipboardData.files.length > 0) {
              const customEvent = new CustomEvent("image-paste", {
                bubbles: true,
                detail: {
                  files: event.clipboardData.files
                }
              });
              event.target.dispatchEvent(customEvent);
              return true;
            }
          }
        }
      })
    ];
  }
});
const regexSpaces = /\s+/g;
const regexInvalidCaracters = /[^\p{Letter}\p{Mark}\w\s-]/gu;
const slugify = (str) => String(str).toLowerCase().replace(regexInvalidCaracters, "").trim().replace(regexSpaces, "-");
const setHeadings = (val) => store$1.dispatch("setHeadings", val);
const extractHeadings = (editor) => {
  const counter = /* @__PURE__ */ new Map();
  const headings = [];
  const tr = editor.state.tr;
  const getId = (text) => {
    const id = slugify(text);
    if (counter.has(id)) {
      const next = counter.get(id);
      counter.set(id, next + 1);
      return `${id}--${next}`;
    }
    counter.set(id, 1);
    return id;
  };
  editor.state.doc.descendants((node, position) => {
    var _a2;
    if (node.type.name === "heading") {
      const text = node.textContent;
      const id = getId(text);
      const uuid = (_a2 = node.attrs.uuid) != null ? _a2 : v4();
      if (node.attrs.id !== id || !node.attrs.uuid) {
        const attrs = {
          ...node.attrs,
          uuid,
          id
        };
        tr.setNodeMarkup(position, void 0, attrs);
      }
      headings.push(Object.freeze({
        level: node.attrs.level,
        position,
        text,
        id,
        uuid
      }));
    }
  });
  tr.setMeta("addToHistory", false);
  tr.setMeta("preventUpdate", true);
  editor.view.dispatch(tr);
  setHeadings(headings);
};
const HeadingView_vue_vue_type_style_index_0_lang = "";
const _sfc_main$3 = Vue.extend({
  name: "HeadingView",
  components: {
    NodeViewWrapper,
    NodeViewContent
  },
  mixins: [useEditorMixin],
  props: {
    node: {
      type: Object,
      required: true
    },
    extension: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      content: null
    };
  },
  computed: {
    href() {
      return `#${this.node.attrs.id}`;
    },
    domElement() {
      const hasLevel = this.extension.options.levels.includes(this.node.attrs.level);
      const level = hasLevel ? this.node.attrs.level : this.extension.options.levels[0];
      return `h${level}`;
    },
    linkSymbol() {
      return this.extension.options.linkSymbol;
    },
    t: () => window.t
  },
  methods: {
    click() {
      this.$refs.container.$el.scrollIntoView();
      window.location.hash = this.href;
    }
  }
});
var _sfc_render$3 = function render9() {
  var _vm = this, _c = _vm._self._c;
  _vm._self._setupProxy;
  return _c("NodeViewWrapper", { ref: "container", attrs: { "id": _vm.node.attrs.id, "as": _vm.domElement, "tabindex": "-1" } }, [_c("a", { staticClass: "heading-anchor", attrs: { "aria-hidden": "true", "href": _vm.href, "title": _vm.t("text", "Link to this section"), "contenteditable": false }, on: { "click": function($event) {
    $event.stopPropagation();
    return _vm.click.apply(null, arguments);
  } } }, [_vm._v(_vm._s(_vm.linkSymbol))]), _c("NodeViewContent")], 1);
};
var _sfc_staticRenderFns$3 = [];
var __component__$3 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$3,
  _sfc_render$3,
  _sfc_staticRenderFns$3,
  false,
  null,
  null,
  null,
  null
);
const HeaderViewVue = __component__$3.exports;
const Heading = TipTapHeading.extend({
  addAttributes() {
    return {
      ...this.parent(),
      id: {
        default: void 0,
        rendered: true
      },
      uuid: {
        default: void 0,
        rendered: false
      }
    };
  },
  addOptions() {
    var _a2;
    return {
      ...(_a2 = this.parent) == null ? void 0 : _a2.call(this),
      linkSymbol: "#"
    };
  },
  addKeyboardShortcuts() {
    return this.options.levels.reduce((items, level) => ({
      ...items,
      [`Mod-Shift-${level}`]: () => this.editor.commands.toggleHeading({ level })
    }), {});
  },
  addNodeView() {
    return VueNodeViewRenderer(HeaderViewVue, {
      update: ({ oldNode, newNode, updateProps }) => {
        if (newNode.type.name !== this.name)
          return false;
        if (newNode.attrs !== oldNode.attrs)
          return false;
        updateProps();
        return true;
      }
    });
  },
  onDestroy() {
    setHeadings([]);
    if (this.parent) {
      this.parent();
    }
  },
  onCreate() {
    extractHeadings(this.editor);
    if (this.parent) {
      this.parent();
    }
  },
  onUpdate: debounce(function onUpdate({ editor }) {
    extractHeadings(editor);
  }, 900)
});
/*
 * @copyright Copyright (c) 2021 Jonas Meurer <jonas@freesources.org>
 *
 * @author Jonas Meurer <jonas@freesources.org>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function listInputRule(find, type, getAttributes) {
  const handler = ({ state, range, match }) => {
    const wrap = wrappingInputRule({ find, type, getAttributes });
    wrap.handler({ state, range, match });
    if (match.length >= 3) {
      state.tr.insertText(match[2]);
    }
  };
  return new InputRule({ find, handler });
}
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const BulletList = TiptapBulletList.extend({
  parseHTML() {
    return this.parent().map((rule) => Object.assign(rule, { preserveWhitespace: true }));
  },
  addInputRules() {
    return [
      listInputRule(
        /^\s*([-+*])\s([^\s[]+)$/,
        this.type
      )
    ];
  }
});
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const TaskList = TiptapTaskList.extend({
  parseHTML: [
    {
      priority: 100,
      tag: "ul.contains-task-list"
    }
  ],
  toMarkdown: (state, node) => {
    state.renderList(node, "  ", () => (node.attrs.bullet || "*") + " ");
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const TaskItem = TipTapTaskItem.extend({
  addOptions() {
    return {
      nested: true,
      HTMLAttributes: {}
    };
  },
  draggable: false,
  content: "paragraph block*",
  addAttributes() {
    const adjust = { ...this.parent() };
    adjust.checked.parseHTML = (el) => {
      var _a2;
      return (_a2 = el.querySelector("input[type=checkbox]")) == null ? void 0 : _a2.checked;
    };
    return adjust;
  },
  parseHTML: [
    {
      priority: 101,
      tag: "li",
      getAttrs: (el) => {
        const checkbox = el.querySelector("input[type=checkbox]");
        return checkbox;
      },
      context: "taskList/"
    }
  ],
  renderHTML({ node, HTMLAttributes }) {
    const listAttributes = { class: "checkbox-item" };
    const checkboxAttributes = { type: "checkbox", class: "", contenteditable: false };
    if (node.attrs.checked) {
      checkboxAttributes.checked = true;
      listAttributes.class += " checked";
    }
    return [
      "li",
      mergeAttributes(HTMLAttributes, listAttributes),
      [
        "input",
        checkboxAttributes
      ],
      [
        "label",
        0
      ]
    ];
  },
  addNodeView: false,
  toMarkdown: (state, node) => {
    state.write(`[${node.attrs.checked ? "x" : " "}] `);
    state.renderContent(node);
  },
  addInputRules() {
    return [
      ...this.parent(),
      wrappingInputRule({
        find: /^\s*([-+*])\s(\[(x|X|\s?)\])\s$/,
        type: this.type,
        getAttributes: (match) => ({
          checked: "xX".includes(match[match.length - 1])
        })
      })
    ];
  },
  addProseMirrorPlugins() {
    return [
      new Plugin({
        props: {
          handleClick: (view, pos, event) => {
            const state = view.state;
            const schema = state.schema;
            const coordinates = view.posAtCoords({ left: event.clientX, top: event.clientY });
            const position = state.doc.resolve(coordinates.pos);
            const parentList = findParentNodeClosestToPos(position, function(node) {
              return node.type === schema.nodes.taskItem || node.type === schema.nodes.listItem;
            });
            const isListClicked = event.target.tagName.toLowerCase() === "li";
            if (!isListClicked || !parentList || parentList.node.type !== schema.nodes.taskItem) {
              return;
            }
            const tr = state.tr;
            tr.setNodeMarkup(parentList.pos, schema.nodes.taskItem, { checked: !parentList.node.attrs.checked });
            view.dispatch(tr);
          }
        }
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const typesAvailable = ["info", "warn", "error", "success"];
const buildRender = (type) => (tokens, idx, options, env, slf) => {
  const tag = tokens[idx];
  if (tag.nesting === 1) {
    tag.attrSet("data-callout", type);
    tag.attrJoin("class", `callout callout-${type}`);
  }
  return slf.renderToken(tokens, idx, options, env, slf);
};
const callouts = (md) => {
  typesAvailable.forEach((type) => {
    md.use(container, type, {
      render: buildRender(type)
    });
  });
  return md;
};
const Callout_vue_vue_type_style_index_0_scoped_253867f9_lang = "";
const ICONS_MAP = {
  info: Info,
  success: Positive,
  error: Danger,
  warn: Warn
};
const _sfc_main$2 = {
  name: "Callout",
  components: {
    NodeViewWrapper,
    NodeViewContent
  },
  props: {
    node: {
      type: Object,
      required: true
    }
  },
  computed: {
    icon() {
      return ICONS_MAP[this.type] || Info;
    },
    type() {
      var _a2, _b2;
      return ((_b2 = (_a2 = this.node) == null ? void 0 : _a2.attrs) == null ? void 0 : _b2.type) || "info";
    }
  }
};
var _sfc_render$2 = function render10() {
  var _vm = this, _c = _vm._self._c;
  return _c("NodeViewWrapper", { staticClass: "callout", class: `callout--${_vm.type}`, attrs: { "data-text-el": "callout", "as": "div" } }, [_c(_vm.icon, { tag: "component", staticClass: "callout__icon" }), _c("NodeViewContent", { staticClass: "callout__content" })], 1);
};
var _sfc_staticRenderFns$2 = [];
var __component__$2 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$2,
  _sfc_render$2,
  _sfc_staticRenderFns$2,
  false,
  null,
  "253867f9",
  null,
  null
);
const Callout$1 = __component__$2.exports;
/*
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Callout = Node.create({
  name: "callout",
  content: "paragraph+",
  group: "block",
  defining: true,
  addOptions() {
    return {
      types: typesAvailable,
      HTMLAttributes: {
        class: "callout"
      }
    };
  },
  addAttributes() {
    return {
      type: {
        default: "info",
        rendered: false,
        parseHTML: (element) => {
          return element.getAttribute("data-callout") || typesAvailable.find((type) => element.classList.contains(type)) || element.classList.contains("warning") && "warn";
        },
        renderHTML: (attributes) => {
          return {
            "data-callout": attributes.type,
            class: `callout-${attributes.type}`
          };
        }
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: "div.callout"
      },
      {
        tag: "p.callout",
        priority: 1001
      }
    ];
  },
  renderHTML({ node, HTMLAttributes }) {
    const { class: classy } = this.options.HTMLAttributes;
    const attributes = {
      ...this.options.HTMLAttributes,
      "data-callout": node.attrs.type,
      class: `${classy} ${classy}-${node.attrs.type}`
    };
    return ["div", mergeAttributes(attributes, HTMLAttributes), 0];
  },
  toMarkdown: (state, node) => {
    state.write("::: " + (node.attrs.type || "info") + "\n");
    state.renderContent(node);
    state.ensureNewLine();
    state.write(":::");
    state.closeBlock(node);
  },
  addNodeView() {
    return VueNodeViewRenderer(Callout$1);
  },
  addCommands() {
    return {
      setCallout: (attributes) => ({ commands }) => {
        return commands.wrapIn(this.name, attributes);
      },
      toggleCallout: (attributes) => ({ commands, state }) => {
        if (!isNodeActive(state, this.name)) {
          return commands.setCallout(attributes);
        }
        if (!isNodeActive(state, this.name, attributes)) {
          return commands.updateAttributes(this.name, attributes);
        }
        return commands.unsetCallout();
      },
      unsetCallout: () => ({ commands }) => {
        return commands.lift(this.name);
      }
    };
  }
});
const Mention_vue_vue_type_style_index_0_scoped_94fe9c88_lang = "";
const _sfc_main$1 = {
  name: "Mention",
  components: {
    NcUserBubble,
    NodeViewWrapper
  },
  props: {
    updateAttributes: {
      type: Function,
      required: true
    },
    node: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      username: this.node.attrs.label
    };
  },
  computed: {
    isCurrentUser() {
      var _a2;
      return this.node.attrs.id === ((_a2 = getCurrentUser()) == null ? void 0 : _a2.uid);
    }
  }
};
var _sfc_render$1 = function render11() {
  var _vm = this, _c = _vm._self._c;
  return _c("NodeViewWrapper", { staticClass: "mention", attrs: { "as": "span", "contenteditable": "false" } }, [_c("NcUserBubble", { staticClass: "mention-user-bubble", attrs: { "user": _vm.node.attrs.id, "display-name": _vm.username, "primary": _vm.isCurrentUser } }, [_vm._v(" @" + _vm._s(_vm.username) + " ")])], 1);
};
var _sfc_staticRenderFns$1 = [];
var __component__$1 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$1,
  _sfc_render$1,
  _sfc_staticRenderFns$1,
  false,
  null,
  "94fe9c88",
  null,
  null
);
const Mention$1 = __component__$1.exports;
const Mention = TipTapMention.extend({
  parseHTML() {
    return [
      {
        tag: 'span[data-type="user"]',
        getAttrs: (element) => {
          var _a2;
          return {
            id: element.getAttribute("data-id"),
            label: (_a2 = element.innerText) != null ? _a2 : element.getAttribute("data-id")
          };
        },
        priority: 100
      }
    ];
  },
  addNodeView() {
    return VueNodeViewRenderer(Mention$1);
  },
  toMarkdown(state, node) {
    state.write(" ");
    state.write(`@[${node.attrs.label}](mention://user/${node.attrs.id})`);
    state.write(" ");
  }
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function markdownUnderlines(md) {
  md.inline.ruler2.after("emphasis", "underline", (state) => {
    const tokens = state.tokens;
    for (let i = tokens.length - 1; i > 0; i--) {
      const token = tokens[i];
      if (token.markup === "__") {
        if (token.type === "strong_open") {
          tokens[i].tag = "u";
          tokens[i].type = "u_open";
        }
        if (token.type === "strong_close") {
          tokens[i].tag = "u";
          tokens[i].type = "u_close";
        }
      }
    }
    return false;
  });
}
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function splitMixedLists(md) {
  md.core.ruler.after("task-lists", "split-mixed-task-lists", (state) => {
    const tokens = state.tokens;
    for (let i = 0; i < tokens.length; i++) {
      const token = tokens[i];
      if (!includesClass(token, "contains-task-list")) {
        continue;
      }
      const firstChild = tokens[i + 1];
      const startsWithTask = includesClass(firstChild, "task-list-item");
      if (!startsWithTask) {
        token.attrs.splice(token.attrIndex("class"));
        if (token.attrs.length === 0) {
          token.attrs = null;
        }
      }
      const splitBefore = findChildOf(tokens, i, (child) => {
        return child.nesting === 1 && includesClass(child, "task-list-item") !== startsWithTask;
      });
      if (splitBefore > i) {
        splitListAt(tokens, splitBefore, state.Token);
      }
    }
    return false;
  });
}
function includesClass(token, cls) {
  var _a2;
  return ((_a2 = token.attrGet("class")) == null ? void 0 : _a2.split(" ").includes(cls)) || false;
}
function splitListAt(tokens, index, TokenConstructor) {
  const closeList = new TokenConstructor("bullet_list_close", "ul", -1);
  closeList.block = true;
  const openList = new TokenConstructor("bullet_list_open", "ul", 1);
  openList.attrSet("class", "contains-task-list");
  openList.block = true;
  tokens.splice(index, 0, closeList, openList);
}
function findChildOf(tokens, parentIndex, predicate) {
  const searchLevel = tokens[parentIndex].level + 1;
  for (let i = parentIndex + 1; i < tokens.length; i++) {
    const token = tokens[i];
    if (token.level < searchLevel) {
      return -1;
    }
    if (token.level === searchLevel && predicate(tokens[i])) {
      return i;
    }
  }
  return -1;
}
/**
 * @copyright Copyright (c) 2022
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function keepSyntax(md) {
  const escaped = /(\n(?<linestart>[#\-*+>])|(?<special>[`*\\~[\]]+))/;
  md.core.ruler.before("text_join", "tag-markdown-syntax", (state) => {
    var _a2;
    const open = new state.Token("keep_md_open", "span", 1);
    open.attrSet("class", "keep-md");
    const close = new state.Token("keep_md_close", "span", -1);
    for (let i = 0; i < state.tokens.length; i++) {
      const block = state.tokens[i];
      if (block.type !== "inline")
        continue;
      for (let j = 0; j < block.children.length; j++) {
        const token = block.children[j];
        if (token.type === "text") {
          const match = escaped.exec(token.content);
          if (match) {
            const index = match.groups.linestart ? match.index + 1 : match.index;
            const matchChars = (_a2 = match.groups.linestart) != null ? _a2 : match.groups.special;
            const contentNext = index + matchChars.length;
            block.children.splice(
              j,
              1,
              Object.assign({}, token, { content: token.content.slice(0, index) }),
              Object.assign({}, open),
              Object.assign({}, token, { content: token.content.slice(index, contentNext) }),
              Object.assign({}, close),
              Object.assign({}, token, { content: token.content.slice(contentNext) })
            );
            j += 3;
          }
        }
      }
    }
    return false;
  });
}
const markdownit = MarkdownIt("commonmark", { html: false, breaks: false }).enable("strikethrough").enable("table").use(taskLists, { enable: true, labelAfter: true }).use(splitMixedLists).use(markdownUnderlines).use(callouts).use(keepSyntax).use(markdownitMentions);
/**
 * @copyright Copyright (c) 2020 Azul <azul@riseup.net>
 *
 * @author Azul <azul@riseup.net>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const absolutePath = function(base, rel) {
  if (!rel) {
    return base;
  }
  if (rel[0] === "/") {
    return rel;
  }
  base = base.split("/");
  rel = rel.split("/");
  while (rel[0] === ".." || rel[0] === ".") {
    if (rel[0] === "..") {
      base.pop();
    }
    rel.shift();
  }
  return base.concat(rel).join("/");
};
const basedir = function(file) {
  const end = file.lastIndexOf("/");
  return end > 0 ? file.slice(0, end) : file.slice(0, end + 1);
};
const domHref = function(node) {
  const ref = node.attrs.href;
  if (!ref) {
    return ref;
  }
  if (ref.match(/^[a-zA-Z]*:/)) {
    return ref;
  }
  if (ref.startsWith("#")) {
    return ref;
  }
  const match = ref.match(/^([^?]*)\?fileId=(\d+)/);
  if (match) {
    const [, relPath, id] = match;
    const currentDir = basedir(OCA.Viewer.file);
    const dir = absolutePath(currentDir, basedir(relPath));
    return generateUrl(`/apps/files/?dir=${dir}&openfile=${id}#relPath=${relPath}`);
  }
};
const parseHref = function(dom) {
  const ref = dom.getAttribute("href");
  if (!ref) {
    return ref;
  }
  const match = ref.match(/\?dir=([^&]*)&openfile=([^&]*)#relPath=([^&]*)/);
  if (match) {
    const [, , id, path] = match;
    return `${path}?fileId=${id}`;
  }
  return ref;
};
const openLink = function(event, _attrs) {
  const linkElement = event.target.closest("a");
  const htmlHref = linkElement.href;
  const query = OC.parseQueryString(htmlHref);
  const fragment = htmlHref.split("#").pop();
  const fragmentQuery = OC.parseQueryString(fragment);
  if ((query == null ? void 0 : query.dir) && (fragmentQuery == null ? void 0 : fragmentQuery.relPath)) {
    const filename = fragmentQuery.relPath.split("/").pop();
    const path = `${query.dir}/${filename}`;
    document.title = `${filename} - ${OC.theme.title}`;
    if (window.location.pathname.match(/apps\/files\/$/))
      ;
    OCA.Viewer.open({ path });
    return;
  }
  if (query == null ? void 0 : query.fileId) {
    window.open(generateUrl(`/f/${query.fileId}`));
    return;
  }
  if (!markdownit.validateLink(htmlHref)) {
    logger.error("Invalid link", { htmlHref });
    return false;
  }
  if (fragment) {
    const el = document.getElementById(fragment);
    if (el) {
      el.scrollIntoView();
      window.location.hash = fragment;
      return;
    }
  }
  window.open(htmlHref);
  return true;
};
const clickHandler = ({ editor, type, onClick }) => {
  return new Plugin({
    props: {
      key: new PluginKey("textLink"),
      handleClick: (view, pos, event) => {
        const $clicked = view.state.doc.resolve(pos);
        const link = $clicked.marks().find((m) => m.type.name === type.name);
        if (!link) {
          return false;
        }
        if (!link.attrs.href) {
          logger.warn("Could not determine href of link.");
          logger.debug("Link", { link });
          return false;
        }
        if (event.button === 0 && !event.ctrlKey) {
          event.stopPropagation();
          return onClick == null ? void 0 : onClick(event, link.attrs);
        }
      }
    }
  });
};
/*
 * @copyright Copyright (c) 2019 Azul <azul@riseup.net>
 *
 * @author Azul <azul@riseup.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Link = TipTapLink.extend({
  addOptions() {
    var _a2;
    return {
      ...(_a2 = this.parent) == null ? void 0 : _a2.call(this),
      onClick: openLink
    };
  },
  addAttributes() {
    return {
      href: {
        default: null
      },
      title: {
        default: null
      }
    };
  },
  inclusive: false,
  parseHTML: [
    {
      tag: "a[href]",
      getAttrs: (dom) => ({
        href: parseHref(dom),
        title: dom.getAttribute("title")
      })
    }
  ],
  renderHTML: ({ mark, HTMLAttributes }) => ["a", {
    ...mark.attrs,
    href: domHref(mark),
    rel: "noopener noreferrer nofollow"
  }, 0],
  addProseMirrorPlugins() {
    const plugins = this.parent().filter(({ key }) => {
      return !key.startsWith("handleClickLink");
    });
    if (!this.options.openOnClick) {
      return plugins;
    }
    return [
      ...plugins,
      clickHandler({
        editor: this.editor,
        type: this.type,
        onClick: this.options.onClick
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Strike = TipTapStrike.extend({
  parseHTML() {
    return [
      {
        tag: "s"
      },
      {
        tag: "del"
      },
      {
        tag: "strike"
      },
      {
        style: "text-decoration",
        getAttrs: (value) => value === "line-through"
      }
    ];
  },
  renderHTML() {
    return ["s", 0];
  },
  toMarkdown: {
    open: "~~",
    close: "~~",
    mixable: true,
    expelEnclosingWhitespace: true
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Strong = Bold.extend({
  name: "strong",
  addInputRules() {
    return [
      markInputRule({
        find: starInputRegex,
        type: this.type
      })
    ];
  },
  addPasteRules() {
    return [
      markPasteRule({
        find: starPasteRegex,
        type: this.type
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Underline = TipTapUnderline.extend({
  parseHTML() {
    return [
      {
        tag: "u"
      },
      {
        style: "text-decoration",
        getAttrs: (value) => value === "underline"
      }
    ];
  },
  renderHTML() {
    return ["u", 0];
  },
  toMarkdown: {
    open: "__",
    close: "__",
    mixable: true,
    expelEnclosingWhitespace: true
  },
  addInputRules() {
    return [
      markInputRule({
        find: underscoreInputRegex,
        type: this.type
      })
    ];
  },
  addPasteRules() {
    return [
      markPasteRule({
        find: underscorePasteRegex,
        type: this.type
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Italic = TipTapItalic.extend({
  name: "em"
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
*/
const Paragraph = TipTapParagraph.extend({
  parseHTML() {
    return this.parent().map((rule) => Object.assign(rule, { preserveWhitespace: "full" }));
  }
});
const RichText = Extension.create({
  name: "RichText",
  addOptions() {
    return {
      link: {},
      extensions: []
    };
  },
  addExtensions() {
    const defaultExtensions = [
      Document,
      Text,
      Paragraph,
      HardBreak,
      Heading,
      Strong,
      Italic,
      Strike,
      Blockquote,
      Code,
      TiptapCodeBlock,
      BulletList,
      HorizontalRule,
      OrderedList,
      ListItem,
      Table,
      TaskList,
      TaskItem,
      Callout,
      Underline,
      Image$1.configure({
        inline: true
      }),
      Dropcursor,
      KeepSyntax,
      FrontMatter,
      Mention.configure({
        HTMLAttributes: {
          class: "mention"
        }
      })
    ];
    if (this.options.link !== false) {
      defaultExtensions.push(Link.configure({
        ...this.options.link,
        openOnClick: true,
        validate: (href) => /^https?:\/\//.test(href)
      }));
    }
    const additionalExtensionNames = this.options.extensions.map((e) => e.name);
    return [
      ...this.options.extensions,
      ...defaultExtensions.filter((e) => !additionalExtensionNames.includes(e.name))
    ];
  }
});
const RichTextReader_vue_vue_type_style_index_0_lang = "";
const _sfc_main = {
  name: "RichTextReader",
  components: { BaseReader },
  provide: {
    renderHtml(content) {
      return markdownit.render(content);
    },
    extensions() {
      return [
        RichText.configure({
          link: {
            onClick: (event, attrs) => {
              this.$emit("click-link", event, attrs);
              return true;
            }
          }
        })
      ];
    }
  },
  props: {
    content: {
      type: String,
      required: true
    }
  },
  mounted() {
    this.$el.addEventListener("click", this.preventOpeningLinks, true);
  },
  unmounted() {
    this.$el.removeEventListener("click", this.preventOpeningLinks, true);
  },
  methods: {
    preventOpeningLinks(event) {
      if (event.target.closest("a") && event.button === 0 && !event.ctrlKey) {
        event.preventDefault();
      }
    }
  }
};
var _sfc_render = function render12() {
  var _vm = this, _c = _vm._self._c;
  return _c("BaseReader", { attrs: { "content": _vm.content }, on: { "click-link": (e, a) => _vm.$emit("click-link", e, a) } });
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const RichTextReader = __component__.exports;
/**
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license AGPL-3.0-or-later
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
class AttachmentResolver {
  constructor({ session, user, shareToken, currentDirectory, fileId }) {
    __privateAdd(this, _getImageAttachmentUrl);
    __privateAdd(this, _getMediaPreviewUrl);
    __privateAdd(this, _textApiParams);
    __privateAdd(this, _previewUrl);
    __privateAdd(this, _davUrl);
    __privateAdd(this, _relativePath);
    __privateAdd(this, _filePath);
    __privateAdd(this, _session, void 0);
    __privateAdd(this, _user, void 0);
    __privateAdd(this, _shareToken, void 0);
    __privateAdd(this, _currentDirectory, void 0);
    __privateAdd(this, _attachmentDirectory, void 0);
    __publicField(this, "ATTACHMENT_TYPE_IMAGE", "image");
    __publicField(this, "ATTACHMENT_TYPE_MEDIA", "media");
    __privateSet(this, _session, session);
    __privateSet(this, _user, user);
    __privateSet(this, _shareToken, shareToken);
    __privateSet(this, _currentDirectory, currentDirectory);
    fileId || (fileId = session == null ? void 0 : session.documentId);
    __privateSet(this, _attachmentDirectory, `.attachments.${fileId}`);
  }
  resolve(src) {
    var _a2, _b2;
    if (__privateGet(this, _session) && src.startsWith("text://")) {
      const imageFileName = getQueryVariable(src, "imageFileName");
      return [{
        type: this.ATTACHMENT_TYPE_IMAGE,
        url: __privateMethod(this, _getImageAttachmentUrl, getImageAttachmentUrl_fn).call(this, imageFileName)
      }];
    }
    if (__privateGet(this, _session) && src.startsWith(`.attachments.${(_a2 = __privateGet(this, _session)) == null ? void 0 : _a2.documentId}/`)) {
      const imageFileName = decodeURIComponent(src.replace(`.attachments.${(_b2 = __privateGet(this, _session)) == null ? void 0 : _b2.documentId}/`, "").split("?")[0]);
      return [
        {
          type: this.ATTACHMENT_TYPE_IMAGE,
          url: __privateMethod(this, _getImageAttachmentUrl, getImageAttachmentUrl_fn).call(this, imageFileName)
        },
        {
          type: this.ATTACHMENT_TYPE_MEDIA,
          url: __privateMethod(this, _getMediaPreviewUrl, getMediaPreviewUrl_fn).call(this, imageFileName),
          name: imageFileName
        }
      ];
    }
    if (isDirectUrl(src)) {
      return [{
        type: this.ATTACHMENT_TYPE_IMAGE,
        url: src
      }];
    }
    if (hasPreview(src)) {
      return [{
        type: this.ATTACHMENT_TYPE_IMAGE,
        url: __privateMethod(this, _previewUrl, previewUrl_fn).call(this, src)
      }];
    }
    if (src.match(/^\.attachments\.\d+\//)) {
      const imageFileName = __privateMethod(this, _relativePath, relativePath_fn).call(this, src).replace(/\.attachments\.\d+\//, "");
      return [
        {
          type: this.ATTACHMENT_TYPE_IMAGE,
          url: __privateMethod(this, _davUrl, davUrl_fn).call(this, src)
        },
        {
          type: this.ATTACHMENT_TYPE_IMAGE,
          url: __privateMethod(this, _getImageAttachmentUrl, getImageAttachmentUrl_fn).call(this, imageFileName)
        },
        {
          type: this.ATTACHMENT_TYPE_MEDIA,
          url: __privateMethod(this, _getMediaPreviewUrl, getMediaPreviewUrl_fn).call(this, imageFileName),
          name: imageFileName
        }
      ];
    }
    return [{
      type: this.ATTACHMENT_TYPE_IMAGE,
      url: __privateMethod(this, _davUrl, davUrl_fn).call(this, src)
    }];
  }
  getMediaMetadataUrl(mediaFileName) {
    if (__privateGet(this, _user) || !__privateGet(this, _shareToken)) {
      return generateUrl("/apps/text/mediaMetadata?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&mediaFileName={mediaFileName}", {
        ...__privateMethod(this, _textApiParams, textApiParams_fn).call(this),
        mediaFileName
      });
    }
    return generateUrl("/apps/text/mediaMetadata?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&mediaFileName={mediaFileName}&shareToken={shareToken}", {
      ...__privateMethod(this, _textApiParams, textApiParams_fn).call(this),
      mediaFileName,
      shareToken: __privateGet(this, _shareToken)
    });
  }
}
_session = new WeakMap();
_user = new WeakMap();
_shareToken = new WeakMap();
_currentDirectory = new WeakMap();
_attachmentDirectory = new WeakMap();
_getImageAttachmentUrl = new WeakSet();
getImageAttachmentUrl_fn = function(imageFileName) {
  if (!__privateGet(this, _session)) {
    return __privateMethod(this, _davUrl, davUrl_fn).call(this, `${__privateGet(this, _attachmentDirectory)}/${imageFileName}`);
  }
  if (__privateGet(this, _user) || !__privateGet(this, _shareToken)) {
    return generateUrl("/apps/text/image?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&imageFileName={imageFileName}", {
      ...__privateMethod(this, _textApiParams, textApiParams_fn).call(this),
      imageFileName
    });
  }
  return generateUrl("/apps/text/image?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&imageFileName={imageFileName}&shareToken={shareToken}", {
    ...__privateMethod(this, _textApiParams, textApiParams_fn).call(this),
    imageFileName,
    shareToken: __privateGet(this, _shareToken)
  });
};
_getMediaPreviewUrl = new WeakSet();
getMediaPreviewUrl_fn = function(mediaFileName) {
  if (__privateGet(this, _user) || !__privateGet(this, _shareToken)) {
    return generateUrl("/apps/text/mediaPreview?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&mediaFileName={mediaFileName}", {
      ...__privateMethod(this, _textApiParams, textApiParams_fn).call(this),
      mediaFileName
    });
  }
  return generateUrl("/apps/text/mediaPreview?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&mediaFileName={mediaFileName}&shareToken={shareToken}", {
    ...__privateMethod(this, _textApiParams, textApiParams_fn).call(this),
    mediaFileName,
    shareToken: __privateGet(this, _shareToken)
  });
};
_textApiParams = new WeakSet();
textApiParams_fn = function() {
  if (__privateGet(this, _session)) {
    return {
      documentId: __privateGet(this, _session).documentId,
      sessionId: __privateGet(this, _session).id,
      sessionToken: __privateGet(this, _session).token
    };
  }
  return {};
};
_previewUrl = new WeakSet();
previewUrl_fn = function(src) {
  const imageFileId = getQueryVariable(src, "fileId");
  const path = __privateMethod(this, _filePath, filePath_fn).call(this, src);
  const fileQuery = `file=${encodeURIComponent(path)}`;
  const query = fileQuery + "&x=1024&y=1024&a=true";
  if (__privateGet(this, _user) && imageFileId) {
    return generateUrl(`/core/preview?fileId=${imageFileId}&${query}`);
  }
  if (__privateGet(this, _user)) {
    return generateUrl(`/core/preview.png?${query}`);
  }
  if (__privateGet(this, _shareToken)) {
    return generateUrl(`/apps/files_sharing/publicpreview/${__privateGet(this, _shareToken)}?${query}`);
  }
  logger.error("No way to authenticate image retrival - need to be logged in or provide a token");
  return src;
};
_davUrl = new WeakSet();
davUrl_fn = function(src) {
  if (__privateGet(this, _user)) {
    const uid = __privateGet(this, _user).uid;
    const encoded = encodeURI(__privateMethod(this, _filePath, filePath_fn).call(this, src));
    return generateRemoteUrl(`dav/files/${uid}${encoded}`);
  }
  const path = __privateMethod(this, _filePath, filePath_fn).call(this, src).split("/");
  const basename = path.pop();
  const dirname = path.join("/");
  return generateUrl("/s/{token}/download?path={dirname}&files={basename}", {
    token: __privateGet(this, _shareToken),
    basename,
    dirname
  });
};
_relativePath = new WeakSet();
relativePath_fn = function(src) {
  if (src.startsWith("text://")) {
    return [
      __privateGet(this, _attachmentDirectory),
      getQueryVariable(src, "imageFileName")
    ].join("/");
  }
  return decodeURI(src.split("?")[0]);
};
_filePath = new WeakSet();
filePath_fn = function(src) {
  const f = [
    __privateGet(this, _currentDirectory),
    __privateMethod(this, _relativePath, relativePath_fn).call(this, src)
  ].join("/");
  return pathNormalize(f);
};
function isDirectUrl(src) {
  return src.startsWith("http://") || src.startsWith("https://") || src.startsWith("data:") || src.match(/^(\/index.php)?\/core\/preview/) || src.match(/^(\/index.php)?\/apps\/files_sharing\/publicpreview\//);
}
function hasPreview(src) {
  return getQueryVariable(src, "hasPreview") === "true";
}
function getQueryVariable(src, variable) {
  const query = src.split("?")[1];
  if (typeof query === "undefined") {
    return;
  }
  const vars = query.split(/[&#]/);
  if (typeof vars === "undefined") {
    return;
  }
  for (let i = 0; i < vars.length; i++) {
    const pair = vars[i].split("=");
    if (decodeURIComponent(pair[0]) === variable) {
      return decodeURIComponent(pair[1]);
    }
  }
}
export {
  ATTACHMENT_RESOLVER,
  AttachmentResolver,
  RichTextReader
};
